import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.InetAddress;

public class TCPTest {
	private static class Receiver extends Thread {
		Socket sock;
		Receiver(Socket sock) throws Exception {
			this.sock = sock;
			start();
		}
		public void run() {
			try {
				DataInputStream din
					= new DataInputStream(sock.getInputStream());
				while (true) {
					int length = din.readUnsignedShort();
					byte[] buf = new byte[length];
					din.readFully(buf);
					ReflectorPacket rp
						= new ReflectorPacket(sock, buf, length);
					System.out.println("RECV=" + rp);
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}
	public static void main(String[] args) throws Exception {
		if (args.length < 2) {
			System.err.println(
				"usage: java TCPTest SERVERNAME SERVERPORT");
			System.exit(0);
		}
		InetAddress server_address = InetAddress.getByName(args[0]);
		int server_port = Integer.parseInt(args[1]);
		Socket sock = new Socket(server_address, server_port);
		new Receiver(sock);
		DataOutputStream dout = new DataOutputStream(sock.getOutputStream());
		// packet 1
		byte[] buf = {
			0x10, 0x00
		};
		dout.writeShort(buf.length);
		dout.write(buf);
		// packet 2
		byte[] buf2 = {
			0x11, 0x00, 0x01, 0x01, 0x00, (byte) 0xba, (byte) 0xca, 0x01, 0x31, 0x32, 0x33, 0x34, 0x00, 0x01, 0x02, 0x03, 0x04
		};
		dout.writeShort(buf2.length);
		dout.write(buf2);
		// packet 3
		byte[] buf3 = {
			0x11, 0x00, 0x01, 0x01, 0x00, (byte) 0xba, (byte) 0xca, 0x02, 0x31, 0x32, 0x33, 0x34, 0x00
		};
		dout.writeShort(buf3.length);
		dout.write(buf3);
	}
}
